Attribute VB_Name = "Common"
Option Explicit

Private wHWND As Long
Private wHDC As Long
' ,   .
Private RectForm As RECT
'
'  
Private sX As Single
Private sY As Single
Private bEdge As Boolean
'
Private bRect As Boolean
Private curShape As ShapeTypeEnum
Private R As RECT
'select figure
Private bSelect As Boolean
Private sRect As RECT
Private mvarMakeLine As Boolean
Private startP As POINTAPI
Private endP As POINTAPI
Private PointCount As Integer
'

Public Sub DrawRect(ByVal x As Single, ByVal y As Single)
        
        If bRect Then
                InvalidateCanvas
                'Set the rectangle's values
                If x > sX And y > sY Then
                        SetRect R, sX, sY, x, y
                ElseIf x < sX And y > sY Then
                        SetRect R, x, sY, sX, y
                ElseIf x > sX And y < sY Then
                        SetRect R, sX, y, x, sY
                Else
                        SetRect R, x, y, sX, sY
                End If
                'Draw a focus rectangle on our window
                DrawEdge wHDC, R, EDGE_BUMP, BF_RECT
        End If

End Sub

Public Sub StopDrawRect()

        bRect = False
        FrmMain.Toolbar1.Buttons("Rectangle").Value = tbrUnpressed
        FrmMain.Toolbar1.Buttons("Ellipse").Value = tbrUnpressed
        
        FigCounter = FigCounter + 1
        Select Case curShape
                Case SHAPE_RECT
                        With Figures(FigCounter - 1)
                                .Coord = R
                                .Brush.lbColor = vbWhite
                                .Brush.lbStyle = BS_SOLID
                                .Pen.lopnColor = vbBlack
                                .Pen.lopnWidth.x = 1
                                .Pen.lopnWidth.y = 0
                                .Shape = SHAPE_RECT
                        End With
                Case SHAPE_ELLIPSE
                        With Figures(FigCounter - 1)
                                .Coord = R
                                .Brush.lbColor = vbWhite
                                .Brush.lbStyle = BS_SOLID
                                .Pen.lopnColor = vbBlack
                                .Pen.lopnWidth.x = 1
                                .Pen.lopnWidth.y = 0
                                .Shape = SHAPE_ELLIPSE
                        End With
        End Select
        '      
        CurrentFigure = FigCounter - 1
        '  
        Call InvalidateCanvas
        
End Sub

Public Sub StartDrawRect(ByVal shpType As ShapeTypeEnum)
        curShape = shpType
End Sub

Public Property Get DrawRectIsStarted() As Boolean
        DrawRectIsStarted = bRect
End Property

Public Sub InitDrawRect(ByVal x As Single, ByVal y As Single)
        sX = x
        sY = y
        bRect = True
End Sub

Public Sub StopFocus()
        bEdge = False
End Sub

Public Sub InitFocus(ByVal x As Single, ByVal y As Single)
        sX = x
        sY = y
        bEdge = True
End Sub

Public Sub DrawFocus(ByVal x As Single, ByVal y As Single)
Dim R As RECT
        
        If bEdge Then
                InvalidateCanvas
                'Set the rectangle's values
                If x > sX And y > sY Then
                        SetRect R, sX, sY, x, y
                ElseIf x < sX And y > sY Then
                        SetRect R, x, sY, sX, y
                ElseIf x > sX And y < sY Then
                        SetRect R, sX, y, x, sY
                Else
                        SetRect R, x, y, sX, sY
                End If
                'Draw a focus rectangle on our window
                DrawFocusRect wHDC, R
        End If

End Sub

Public Sub InitScreen(pic As PictureBox)

        wHWND = pic.hWnd
        wHDC = pic.hdc
        pic.ScaleMode = vbPixels
        pic.AutoRedraw = True
        '    
        With RectForm
                .Top = 0
                .Left = 0
                .Right = pic.ScaleWidth
                .Bottom = pic.ScaleHeight
        End With
        Call CreateVirtualWindow
        '- 
        FigCounter = 0
        CurrentFigure = -1
        ArrowCounter = 0
        CurrentArrow = -1
        '  
        Call InvalidateCanvas
        
End Sub
'  .    .
'     (  ).
Public Sub CreateVirtualWindow()
Dim CDC As Long

        '    
        CDC = GetDC(wHWND)
        '   
        MDC = CreateCompatibleDC(CDC)
        '        
        MBM = CreateCompatibleBitmap(CDC, RectForm.Right, RectForm.Bottom)
        '  
        ReleaseDC wHWND, CDC
        '      
        SelectObject MDC, MBM
        '     ( )
        PatBlt MDC, 0, 0, RectForm.Right, RectForm.Bottom, WHITENESS
        
End Sub

'   
Public Sub DestroyVirtualWindow()
        '   
        DeleteObject MBM
        '  
        DeleteDC MDC
End Sub

'   ,    .
Public Sub InvalidateCanvas()
Dim i As Integer

        '   RectForm,     .
        '  .
        Call InvalidateRect(wHWND, RectForm, False)
        '     ( )
        PatBlt MDC, 0, 0, RectForm.Right, RectForm.Bottom, WHITENESS
        '  
        If FigCounter > 0 Then
        For i = 0 To UBound(Figures)
                Call DrawFigures(MDC, i)
        Next i
        End If
        If ArrowCounter > 0 Then
        For i = 0 To UBound(Arrows)
                Call DrawArrow(MDC, i)
        Next i
        End If
        '     
        BitBlt wHDC, RectForm.Left, RectForm.Top, RectForm.Right, RectForm.Bottom, MDC, 0, 0, SRCCOPY
        
End Sub

Public Function PointInFigure(ByVal x As Single, ByVal y As Single) As Integer
Dim i As Integer

        PointInFigure = -1
        If FigCounter = 0 Then Exit Function
        For i = 0 To UBound(Figures)
                With Figures(i).Coord
                        If (x > .Left And x < .Right) And (y > .Top And y < .Bottom) Then
                                PointInFigure = i
                                Exit For
                        End If
                End With
        Next i
        
End Function

Public Sub StartSelect(i As Integer, ByVal x As Single, ByVal y As Single)
        If i >= 0 Then
                bSelect = True
                Figures(i).Pen.lopnWidth.x = 2
                sRect = Figures(i).Coord
                CurrentFigure = i
                '  
                InvalidateCanvas
                sX = x
                sY = y
        End If
End Sub

Public Sub StopSelect()

        If bSelect Then
                Figures(CurrentFigure).Pen.lopnWidth.x = 1
                '  
                InvalidateCanvas
                bSelect = False
        End If

End Sub

Public Sub MoveFigure(ByVal x As Single, ByVal y As Single)
Dim dx As Single
Dim dy As Single

        If bSelect Then
                dx = x - sX
                dy = y - sY
                With Figures(CurrentFigure).Coord
                        .Left = sRect.Left + dx
                        .Right = sRect.Right + dx
                        .Bottom = sRect.Bottom + dy
                        .Top = sRect.Top + dy
                End With
                '  
                InvalidateCanvas
        End If
        
End Sub

Public Property Get IsSelected() As Boolean
        IsSelected = bSelect
End Property

Public Property Get MakeLine() As Boolean
        MakeLine = mvarMakeLine
End Property

Public Property Let MakeLine(ByVal vNewValue As Boolean)
        
        If vNewValue = False And mvarMakeLine = True Then
                FrmMain.Toolbar1.Buttons("Line").Value = tbrUnpressed
                ArrowCounter = ArrowCounter + 1
                With Arrows(ArrowCounter - 1)
                        .Brush.lbColor = vbWhite
                        .Brush.lbStyle = BS_SOLID
                        .Pen.lopnColor = vbBlack
                        .Pen.lopnWidth.x = 1
                        .Pen.lopnWidth.y = 0
                        .StartPoint = startP
                        .EndPoint = endP
                End With
                '      
                CurrentArrow = ArrowCounter - 1
                '  
                Call InvalidateCanvas
        Else
        
        End If
        PointCount = 0
        mvarMakeLine = vNewValue
        
End Property

Public Sub SetLine(ByVal x As Single, ByVal y As Single)
        
        If PointCount = 0 Then
                startP.x = x
                startP.y = y
                PointCount = 1
        Else
                endP.x = x
                endP.y = y
                MakeLine = False
        End If
        
End Sub

