Attribute VB_Name = "DrawFigure"
Option Explicit
'  
Public Enum ShapeTypeEnum
        SHAPE_RECT = 0
        SHAPE_ELLIPSE = 1
End Enum
'   
Public Type DrawFigure
        Shape As ShapeTypeEnum    '   (    ..)
        Pen As LOGPEN                          '  
        Brush As LOGBRUSH                '  
        Coord As RECT                            '  
End Type
Public Type ArrowFigure
        Pen As LOGPEN                       '  
        Brush As LOGBRUSH             '  
        StartPoint As POINTAPI          '  
        EndPoint As POINTAPI           '  
End Type
'   (  )
Public Figures(0 To 100) As DrawFigure
Public Arrows(0 To 100) As ArrowFigure
'   
Public CurrentFigure As Integer
Public CurrentArrow As Integer
'  
Public CurrentColor As Long
'- 
Public FigCounter As Integer
Public ArrowCounter As Integer
'

'      
' HDC - ,   
' IndexFigure -  ,   
Sub DrawFigures(hdc As Long, IndexFigure As Integer)
'  
Dim NewPen, OldPen As Long
'  
Dim NewBrush, OldBrush As Long

        '      
        NewPen = CreatePenIndirect(Figures(IndexFigure).Pen)
        '      
        NewBrush = CreateBrushIndirect(Figures(IndexFigure).Brush)
        '        
        OldPen = SelectObject(hdc, NewPen)
        OldBrush = SelectObject(hdc, NewBrush)
        Select Case Figures(IndexFigure).Shape
                Case SHAPE_RECT:
                        Call ShapeRect(hdc, Figures(IndexFigure).Coord)
                Case SHAPE_ELLIPSE:
                        Call ShapeEllipse(hdc, Figures(IndexFigure).Coord)
        End Select
        '       
        '    
        SelectObject hdc, OldBrush
        SelectObject hdc, OldPen
        '     
        '     
        DeleteObject (NewBrush)
        DeleteObject (NewPen)
        
End Sub

'  .
' HDC -  
' R -    
Sub ShapeRect(hdc As Long, R As RECT)
        Call Rectangle(hdc, R.Left, R.Top, R.Right, R.Bottom)
End Sub

'  .
' HDC -  
' R -    
Sub ShapeEllipse(hdc As Long, R As RECT)
        Call Ellipse(hdc, R.Left, R.Top, R.Right, R.Bottom)
End Sub

Public Sub DrawArrow(hdc As Long, IndexArrow As Integer)
Dim pts() As POINTAPI
Dim p1 As POINTAPI
Dim p2 As POINTAPI
'  
Dim NewPen, OldPen As Long
'  
Dim NewBrush, OldBrush As Long
        
        With Arrows(IndexArrow)
                p1.x = .StartPoint.x
                p1.y = .StartPoint.y
                p2.x = .EndPoint.x
                p2.y = .EndPoint.y
                '      
                NewPen = CreatePenIndirect(.Pen)
                '      
                NewBrush = CreateBrushIndirect(.Brush)
        End With
        '        
        OldPen = SelectObject(hdc, NewPen)
        OldBrush = SelectObject(hdc, NewBrush)
        '  
        pts = GetPolyArrow(p1, p2)
        '
        Polygon hdc, pts(0), UBound(pts) + 1
        '       
        '    
        SelectObject hdc, OldBrush
        SelectObject hdc, OldPen
        '     
        '     
        DeleteObject (NewBrush)
        DeleteObject (NewPen)
        
End Sub

Private Function GetPolyArrow(StartPt As POINTAPI, EndPt As POINTAPI) As POINTAPI()
Dim pts(0 To 11) As POINTAPI
Dim cmPix As Long
Dim cmPiy As Long
Const cm = 567
        
        cmPix = (cm \ 3) / Screen.TwipsPerPixelX
        cmPiy = (cm \ 3) / Screen.TwipsPerPixelY
        
        pts(0).x = StartPt.x: pts(0).y = StartPt.y
        pts(1).x = StartPt.x + cmPix: pts(1).y = StartPt.y
        pts(2).x = EndPt.x - cmPix: pts(2).y = EndPt.y
        pts(3).x = EndPt.x - cmPix \ 3: pts(3).y = EndPt.y
        pts(4).x = EndPt.x - cmPix \ 3: pts(4).y = EndPt.y - cmPiy \ 3
        pts(5).x = EndPt.x: pts(5).y = EndPt.y
        pts(6).x = EndPt.x - cmPix \ 3: pts(6).y = EndPt.y + cmPiy \ 3
        pts(7).x = EndPt.x - cmPix \ 3: pts(7).y = EndPt.y
        pts(8).x = EndPt.x - cmPix: pts(8).y = EndPt.y
        pts(9).x = StartPt.x + cmPix: pts(9).y = StartPt.y
        pts(10).x = StartPt.x: pts(10).y = StartPt.y
        pts(11).x = StartPt.x: pts(11).y = StartPt.y
        
        GetPolyArrow = pts
        
End Function

